One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to build a todo app in React

Building a todo application is a classic way to learn React fundamentals including state management, event handling, and component composition. As the creator of CoreUI, I’ve built todo-style interfaces for task management systems, project tracking tools, and checklist applications. The most effective approach uses useState for managing todos, useEffect for persistence, and controlled inputs for adding new items. This provides a fully functional todo app with all essential features.

Create a basic todo app with add and display functionality.

import { useState } from 'react'

function TodoApp() {
  const [todos, setTodos] = useState([])
  const [inputValue, setInputValue] = useState('')

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      const newTodo = {
        id: Date.now(),
        text: inputValue,
        completed: false
      }
      setTodos([...todos, newTodo])
      setInputValue('')
    }
  }

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <ul>
        {todos.map(todo => (
          <li key={todo.id}>{todo.text}</li>
        ))}
      </ul>
    </div>
  )
}

The todos array stores all todo items. The inputValue tracks the current input. The handleSubmit creates new todos with unique IDs. The form prevents empty todos. The list renders all todos using map.

Adding Toggle Complete Functionality

Implement checkbox to mark todos as completed.

import { useState } from 'react'

function TodoApp() {
  const [todos, setTodos] = useState([])
  const [inputValue, setInputValue] = useState('')

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      setTodos([...todos, {
        id: Date.now(),
        text: inputValue,
        completed: false
      }])
      setInputValue('')
    }
  }

  const toggleTodo = (id) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, completed: !todo.completed } : todo
    ))
  }

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <ul>
        {todos.map(todo => (
          <li key={todo.id}>
            <input
              type="checkbox"
              checked={todo.completed}
              onChange={() => toggleTodo(todo.id)}
            />
            <span style={{ textDecoration: todo.completed ? 'line-through' : 'none' }}>
              {todo.text}
            </span>
          </li>
        ))}
      </ul>
    </div>
  )
}

The toggleTodo function finds the todo by ID and flips its completed state. The checkbox reflects the completed status. Completed todos get strikethrough styling. The map creates a new array preserving immutability.

Adding Delete Functionality

Implement delete buttons to remove todos.

import { useState } from 'react'

function TodoApp() {
  const [todos, setTodos] = useState([])
  const [inputValue, setInputValue] = useState('')

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      setTodos([...todos, {
        id: Date.now(),
        text: inputValue,
        completed: false
      }])
      setInputValue('')
    }
  }

  const toggleTodo = (id) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, completed: !todo.completed } : todo
    ))
  }

  const deleteTodo = (id) => {
    setTodos(todos.filter(todo => todo.id !== id))
  }

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <ul>
        {todos.map(todo => (
          <li key={todo.id}>
            <input
              type="checkbox"
              checked={todo.completed}
              onChange={() => toggleTodo(todo.id)}
            />
            <span style={{ textDecoration: todo.completed ? 'line-through' : 'none' }}>
              {todo.text}
            </span>
            <button onClick={() => deleteTodo(todo.id)}>Delete</button>
          </li>
        ))}
      </ul>
    </div>
  )
}

The deleteTodo function filters out the todo with matching ID. The delete button calls this function. The filter creates a new array without the deleted item. This provides complete CRUD functionality.

Persisting Todos to LocalStorage

Save todos to localStorage so they persist across page refreshes.

import { useState, useEffect } from 'react'

function TodoApp() {
  const [todos, setTodos] = useState(() => {
    const saved = localStorage.getItem('todos')
    return saved ? JSON.parse(saved) : []
  })
  const [inputValue, setInputValue] = useState('')

  useEffect(() => {
    localStorage.setItem('todos', JSON.stringify(todos))
  }, [todos])

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      setTodos([...todos, {
        id: Date.now(),
        text: inputValue,
        completed: false
      }])
      setInputValue('')
    }
  }

  const toggleTodo = (id) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, completed: !todo.completed } : todo
    ))
  }

  const deleteTodo = (id) => {
    setTodos(todos.filter(todo => todo.id !== id))
  }

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <ul>
        {todos.map(todo => (
          <li key={todo.id}>
            <input
              type="checkbox"
              checked={todo.completed}
              onChange={() => toggleTodo(todo.id)}
            />
            <span style={{ textDecoration: todo.completed ? 'line-through' : 'none' }}>
              {todo.text}
            </span>
            <button onClick={() => deleteTodo(todo.id)}>Delete</button>
          </li>
        ))}
      </ul>
    </div>
  )
}

The useState initializer loads saved todos from localStorage. The useEffect saves todos whenever they change. This provides automatic persistence without manual save buttons.

Adding Filter Functionality

Filter todos by completion status.

import { useState, useEffect } from 'react'

function TodoApp() {
  const [todos, setTodos] = useState(() => {
    const saved = localStorage.getItem('todos')
    return saved ? JSON.parse(saved) : []
  })
  const [inputValue, setInputValue] = useState('')
  const [filter, setFilter] = useState('all') // 'all', 'active', 'completed'

  useEffect(() => {
    localStorage.setItem('todos', JSON.stringify(todos))
  }, [todos])

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      setTodos([...todos, {
        id: Date.now(),
        text: inputValue,
        completed: false
      }])
      setInputValue('')
    }
  }

  const toggleTodo = (id) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, completed: !todo.completed } : todo
    ))
  }

  const deleteTodo = (id) => {
    setTodos(todos.filter(todo => todo.id !== id))
  }

  const getFilteredTodos = () => {
    switch (filter) {
      case 'active':
        return todos.filter(todo => !todo.completed)
      case 'completed':
        return todos.filter(todo => todo.completed)
      default:
        return todos
    }
  }

  const filteredTodos = getFilteredTodos()

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <div className="filters">
        <button onClick={() => setFilter('all')}>All</button>
        <button onClick={() => setFilter('active')}>Active</button>
        <button onClick={() => setFilter('completed')}>Completed</button>
      </div>
      <ul>
        {filteredTodos.map(todo => (
          <li key={todo.id}>
            <input
              type="checkbox"
              checked={todo.completed}
              onChange={() => toggleTodo(todo.id)}
            />
            <span style={{ textDecoration: todo.completed ? 'line-through' : 'none' }}>
              {todo.text}
            </span>
            <button onClick={() => deleteTodo(todo.id)}>Delete</button>
          </li>
        ))}
      </ul>
      <p>{filteredTodos.length} items</p>
    </div>
  )
}

The filter state controls which todos display. The getFilteredTodos function returns filtered results. Filter buttons update the filter state. The count shows how many items match the current filter.

Adding Edit Functionality

Implement inline editing for todo text.

import { useState } from 'react'

function TodoItem({ todo, onToggle, onDelete, onEdit }) {
  const [isEditing, setIsEditing] = useState(false)
  const [editValue, setEditValue] = useState(todo.text)

  const handleSubmit = (e) => {
    e.preventDefault()
    if (editValue.trim()) {
      onEdit(todo.id, editValue)
      setIsEditing(false)
    }
  }

  if (isEditing) {
    return (
      <li>
        <form onSubmit={handleSubmit}>
          <input
            type="text"
            value={editValue}
            onChange={(e) => setEditValue(e.target.value)}
            autoFocus
          />
          <button type="submit">Save</button>
          <button type="button" onClick={() => setIsEditing(false)}>Cancel</button>
        </form>
      </li>
    )
  }

  return (
    <li>
      <input
        type="checkbox"
        checked={todo.completed}
        onChange={() => onToggle(todo.id)}
      />
      <span
        style={{ textDecoration: todo.completed ? 'line-through' : 'none' }}
        onDoubleClick={() => setIsEditing(true)}
      >
        {todo.text}
      </span>
      <button onClick={() => setIsEditing(true)}>Edit</button>
      <button onClick={() => onDelete(todo.id)}>Delete</button>
    </li>
  )
}

function TodoApp() {
  const [todos, setTodos] = useState([])
  const [inputValue, setInputValue] = useState('')

  const handleSubmit = (e) => {
    e.preventDefault()
    if (inputValue.trim()) {
      setTodos([...todos, {
        id: Date.now(),
        text: inputValue,
        completed: false
      }])
      setInputValue('')
    }
  }

  const toggleTodo = (id) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, completed: !todo.completed } : todo
    ))
  }

  const deleteTodo = (id) => {
    setTodos(todos.filter(todo => todo.id !== id))
  }

  const editTodo = (id, newText) => {
    setTodos(todos.map(todo =>
      todo.id === id ? { ...todo, text: newText } : todo
    ))
  }

  return (
    <div className="todo-app">
      <h1>Todo List</h1>
      <form onSubmit={handleSubmit}>
        <input
          type="text"
          value={inputValue}
          onChange={(e) => setInputValue(e.target.value)}
          placeholder="Add a new todo..."
        />
        <button type="submit">Add</button>
      </form>
      <ul>
        {todos.map(todo => (
          <TodoItem
            key={todo.id}
            todo={todo}
            onToggle={toggleTodo}
            onDelete={deleteTodo}
            onEdit={editTodo}
          />
        ))}
      </ul>
    </div>
  )
}

The TodoItem component manages edit mode internally. Double-clicking the text or clicking edit enters edit mode. The edit form saves or cancels changes. The editTodo function updates the todo text. This provides full CRUD operations with inline editing.

Best Practice Note

This is the same todo application architecture we use in CoreUI admin templates for task management features. For production applications, add input validation to prevent invalid todos, implement undo/redo functionality for better UX, and add keyboard shortcuts (Enter to add, Escape to cancel edit). Consider adding due dates, priorities, or categories for more complex task management. Implement drag-and-drop reordering for better organization. For team applications, sync todos with a backend API instead of localStorage. Use CoreUI’s form components for professionally styled inputs and buttons that work great in todo interfaces.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
How to concatenate a strings in JavaScript?
How to concatenate a strings in JavaScript?

How to sleep in Javascript
How to sleep in Javascript

How to migrate CoreUI React Templates to Vite
How to migrate CoreUI React Templates to Vite

What is JavaScript Array.pop() Method?
What is JavaScript Array.pop() Method?

One data grid for JavaScript, React, Vue & Angular. Sorting, filtering, virtualization, pinning, and CSV export included. Early access $199 $349 → [Get it now]

How to build a todo app in Angular

Building a todo app in Angular is the ideal project for learning reactive state management, reactive forms, and component communication patterns in a realistic context. As the creator of CoreUI with Angular development experience since 2014, I use this project structure as a reference for the correct separation of concerns between a service for state, a store service for data, and components for display. The state lives in an injectable service using BehaviorSubject so any component in the tree can subscribe to todo changes reactively. This pattern scales from a simple todo app to complex enterprise state management.

Create a todo service that manages state with BehaviorSubject.

// todo.service.ts
import { Injectable } from '@angular/core'
import { BehaviorSubject, map } from 'rxjs'

export interface Todo {
  id: number
  text: string
  completed: boolean
  createdAt: Date
}

@Injectable({ providedIn: 'root' })
export class TodoService {
  private nextId = 1
  private todos$ = new BehaviorSubject<Todo[]>([])

  readonly all$ = this.todos$.asObservable()
  readonly active$ = this.todos$.pipe(map(todos => todos.filter(t => !t.completed)))
  readonly completed$ = this.todos$.pipe(map(todos => todos.filter(t => t.completed)))
  readonly count$ = this.todos$.pipe(map(todos => todos.filter(t => !t.completed).length))

  add(text: string): void {
    if (!text.trim()) return
    const current = this.todos$.value
    this.todos$.next([
      ...current,
      { id: this.nextId++, text: text.trim(), completed: false, createdAt: new Date() }
    ])
  }

  toggle(id: number): void {
    this.todos$.next(
      this.todos$.value.map(t => t.id === id ? { ...t, completed: !t.completed } : t)
    )
  }

  remove(id: number): void {
    this.todos$.next(this.todos$.value.filter(t => t.id !== id))
  }

  clearCompleted(): void {
    this.todos$.next(this.todos$.value.filter(t => !t.completed))
  }
}

BehaviorSubject holds the current state and emits to all subscribers when changed. Derived observables (active$, completed$, count$) automatically update when todos$ changes. No manual subscription management — use the async pipe in templates.

Todo App Component

Build the main component with add form and filter tabs.

// todo-app.component.ts
import { Component } from '@angular/core'
import { CommonModule } from '@angular/common'
import { ReactiveFormsModule, FormControl, Validators } from '@angular/forms'
import { CardModule, FormModule, ButtonModule, BadgeComponent } from '@coreui/angular'
import { TodoService } from './todo.service'
import { TodoItemComponent } from './todo-item.component'

@Component({
  selector: 'app-todo',
  standalone: true,
  imports: [CommonModule, ReactiveFormsModule, CardModule, FormModule, ButtonModule, BadgeComponent, TodoItemComponent],
  template: `
    <c-card style="max-width: 600px; margin: 2rem auto">
      <c-card-header class="d-flex justify-content-between align-items-center">
        <span>Todos</span>
        <c-badge color="primary">{{ todoService.count$ | async }} active</c-badge>
      </c-card-header>
      <c-card-body>
        <form class="d-flex gap-2 mb-4" (ngSubmit)="addTodo()">
          <input
            cFormControl
            [formControl]="newTodo"
            placeholder="What needs to be done?"
          />
          <button cButton color="primary" type="submit">Add</button>
        </form>

        <div class="d-flex gap-2 mb-3">
          <button cButton [color]="filter === 'all' ? 'primary' : 'ghost'" (click)="filter = 'all'">All</button>
          <button cButton [color]="filter === 'active' ? 'primary' : 'ghost'" (click)="filter = 'active'">Active</button>
          <button cButton [color]="filter === 'completed' ? 'primary' : 'ghost'" (click)="filter = 'completed'">Completed</button>
        </div>

        <ng-container [ngSwitch]="filter">
          <app-todo-item
            *ngFor="let todo of (todoService.all$ | async)"
            [todo]="todo"
            *ngSwitchCase="'all'"
          ></app-todo-item>
          <app-todo-item
            *ngFor="let todo of (todoService.active$ | async)"
            [todo]="todo"
            *ngSwitchCase="'active'"
          ></app-todo-item>
          <app-todo-item
            *ngFor="let todo of (todoService.completed$ | async)"
            [todo]="todo"
            *ngSwitchCase="'completed'"
          ></app-todo-item>
        </ng-container>

        <button cButton color="link" class="mt-2" (click)="todoService.clearCompleted()">
          Clear completed
        </button>
      </c-card-body>
    </c-card>
  `
})
export class TodoAppComponent {
  filter: 'all' | 'active' | 'completed' = 'all'
  newTodo = new FormControl('', Validators.required)

  constructor(public todoService: TodoService) {}

  addTodo(): void {
    if (this.newTodo.valid && this.newTodo.value) {
      this.todoService.add(this.newTodo.value)
      this.newTodo.reset()
    }
  }
}

The async pipe subscribes to observables and automatically unsubscribes when the component destroys, preventing memory leaks. Using todoService as public makes it accessible in the template directly.

Best Practice Note

This is the same BehaviorSubject state pattern used in CoreUI Angular templates for lightweight local state. For persistence, add localStorage sync in the service constructor and on every todos$.next() call. To connect to a REST API, replace the in-memory operations with HttpClient calls and use RxJS operators to update the local state after each API response. See how to build a todo API in Node.js for the backend to connect to.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
What’s new and updated in CoreUI 3
What’s new and updated in CoreUI 3

Bootstrap Icons
Bootstrap Icons

Migration from Bootstrap 3 to Bootstrap 4
Migration from Bootstrap 3 to Bootstrap 4

How to upgrade Bootstrap 4 alpha 6 to Bootstrap 4 beta
How to upgrade Bootstrap 4 alpha 6 to Bootstrap 4 beta